<?php
/**
 * @copyright (C) 2021 - 2022 Holger Brandt IT Solutions
 * @license GPL2
*/

if(!defined('ABSPATH')){
    exit;
}

class WADA_EventListener
{
    public $sensors = array();

    public function __construct(){
        $sensorSearchPath = WP_PLUGIN_DIR . '/wp-admin-audit/classes/Sensors/*.php';
        $sensorFiles = glob($sensorSearchPath);
        foreach ($sensorFiles as $sensorFile) {
            $pathParts = pathinfo($sensorFile);
            if($pathParts && array_key_exists('filename', $pathParts) && $pathParts['filename'] !== 'Base'){
                $sensorClassName = 'WADA_Sensor_'.$pathParts['filename'];
                if(class_exists($sensorClassName)){
                    // WADA_Log::info('EventListener adding '.$sensorClassName);
                    $sensor = new $sensorClassName();
                    $this->sensors[] = $sensor;
                }
            }
        }

        $extensionSensors = apply_filters( 'wp_admin_audit_collect_extension_sensors', array() );
        $this->sensors = array_merge($this->sensors, $extensionSensors);

        //WADA_Log::debug('EventListener all sensors: '.print_r($this->sensors, true));
    }

    public function startListening(){
        /** @var WADA_Sensor_Base $sensor */
        foreach($this->sensors AS $sensor){
            $sensor->registerSensor();
        }
    }
}