<?php
/**
 * @copyright (C) 2021 - 2022 Holger Brandt IT Solutions
 * @license GPL2
*/

if(!defined('ABSPATH')){
    exit;
}

class WADA_Version
{
    const PT_NAME = 'WP Admin Audit';
    const PT_DATE = 'July 2022';

    const PT_TOP = '1';
    const PT_SUB = '1';
    const PT_FIX = '2';
    const PT_BET = '-';
    const PT_BLD = '39';

    const FT_RET_OCT    = '36';
    const FT_CSV_EXP    = 'yeah';
    /*
    const FT_MLT_OCT    = '##V_MAX_MAILING_LISTS_OCT##';
    const FT_CAPTCHA    = '##V_CAPTCHA_PROTECTION##';
    const FT_D_FOOTER   = '##V_DISABLE_FOOTER##';
    const FT_DBL_OPT    = '##V_DOUBLE_OPT_IN##';
    const FT_FILTER     = '##V_MAIL_FILTERING##';
    const FT_NOTIFY     = '##V_EVENT_NOTIFICATIONS##';
    const FT_THROTTLE   = '##V_SEND_THROTTLING##';
    const FT_FARCHIVE   = '##V_FRONTEND_ARCHIVE##';
    const FT_CB_INT     = '##V_CB_INTEGRATION##';
    const FT_DD_CRON    = '##V_DEDICATED_CRONJOB##';
    const FT_MODERATE   = '##V_MODERATION_MODE##';
    const FT_DIGEST     = '##V_DIGEST_MODE##';
    const FT_D_ARCHIVE  = '##V_DISABLE_ARCHIVING##';
    const FT_EARCHIVE   = '##V_ENHANCED_ARCHIVING##';
    const FT_REG_PLG    = '##V_REGISTRATION_PLUGIN##';*/

    const UD_OK = 'true';
    const UD_VERSION = 'WP Admin Audit Startup';
    const UD_OPT_1 = 'WP Admin Audit Startup';
    const UD_OPT_2 = 'WP Admin Audit Business';
    const UD_OPT_3 = 'WP Admin Audit Enterprise';
    const UD_LINK = 'https://wpadminaudit.com/upgrade/startup?utm_source=wada&utm_medium=upgrade&utm_campaign=intro';
    
    const FT_ID_RET = 'MAX_RET';
    const FT_ID_CSV_EXP = 'CSV_EXP';
    /*
    const FT_ID_MLT = 'MAX_MLT';
    const FT_ID_CAPTCHA = 'CAPTCHA';
    const FT_ID_D_FOOTER = 'D_FOOTER';
    const FT_ID_DBL_OPT  = 'DBL_OPT';
    const FT_ID_FILTER   = 'FILTER';
    const FT_ID_NOTIFY   = 'NOTIFY';
    const FT_ID_THROTTLE = 'THROTTLE';
    const FT_ID_FARCHIVE = 'FARCHIVE';
    const FT_ID_CB_INT   = 'CB_INT';
    const FT_ID_DD_CRON  = 'DD_CRON';
    const FT_ID_MODERATE = 'MODERATE';
    const FT_ID_DIGEST   = 'DIGEST';
    const FT_ID_D_ARCHIVE = 'D_ARCHIVE';
    const FT_ID_EARCHIVE = 'EARCHIVE';
    const FT_ID_REG_PLG= 'REG_PLG';
    */

    /**
     * @return array
     */
    public static function getFtMap(){
        $ftMap = array();
        $ftMap[self::FT_ID_RET]      = octdec(self::FT_RET_OCT);
        $ftMap[self::FT_ID_CSV_EXP]  = (self::FT_CSV_EXP === 'true');
        /*
        $ftMap[self::FT_ID_MLT]      = octdec(self::FT_MLT_OCT);
        $ftMap[self::FT_ID_CAPTCHA]  = (self::FT_CAPTCHA === 'true');
        $ftMap[self::FT_ID_D_FOOTER] = (self::FT_D_FOOTER === 'true');
        $ftMap[self::FT_ID_DBL_OPT]  = (self::FT_DBL_OPT === 'true');
        $ftMap[self::FT_ID_FILTER]   = (self::FT_FILTER === 'true');
        $ftMap[self::FT_ID_NOTIFY]   = (self::FT_NOTIFY === 'true');
        $ftMap[self::FT_ID_THROTTLE] = (self::FT_THROTTLE === 'true');
        $ftMap[self::FT_ID_FARCHIVE] = (self::FT_FARCHIVE === 'true');
        $ftMap[self::FT_ID_CB_INT]   = (self::FT_CB_INT === 'true');
        $ftMap[self::FT_ID_DD_CRON]  = (self::FT_DD_CRON === 'true');
        $ftMap[self::FT_ID_MODERATE]  = (self::FT_MODERATE === 'true');
        $ftMap[self::FT_ID_DIGEST]   = (self::FT_DIGEST === 'true');
        $ftMap[self::FT_ID_D_ARCHIVE] = (self::FT_D_ARCHIVE === 'true');
        $ftMap[self::FT_ID_EARCHIVE] = (self::FT_EARCHIVE === 'true');
        $ftMap[self::FT_ID_REG_PLG] = (self::FT_REG_PLG === 'true');
        */
        return $ftMap;
    }
    
    public static function getMinV4Ft($ft){
        $ftMap[self::FT_ID_RET]      = null;
        $ftMap[self::FT_ID_CSV_EXP]  = self::UD_OPT_1;
        /*
        $ftMap[self::FT_ID_MLT]      = null;
        $ftMap[self::FT_ID_CAPTCHA]  = self::UD_OPT_1;
        $ftMap[self::FT_ID_D_FOOTER] = self::UD_OPT_1;
        $ftMap[self::FT_ID_DBL_OPT]  = self::UD_OPT_1;
        $ftMap[self::FT_ID_FILTER]   = self::UD_OPT_1;
        $ftMap[self::FT_ID_NOTIFY]   = self::UD_OPT_1;
        $ftMap[self::FT_ID_THROTTLE] = self::UD_OPT_1;
        $ftMap[self::FT_ID_FARCHIVE] = self::UD_OPT_2;
        $ftMap[self::FT_ID_CB_INT]   = self::UD_OPT_2;
        $ftMap[self::FT_ID_DD_CRON]  = self::UD_OPT_2;
        $ftMap[self::FT_ID_MODERATE] = self::UD_OPT_2;
        $ftMap[self::FT_ID_DIGEST]   = self::UD_OPT_2;
        $ftMap[self::FT_ID_D_ARCHIVE] = self::UD_OPT_1;
        $ftMap[self::FT_ID_EARCHIVE] = self::UD_OPT_3;
        $ftMap[self::FT_ID_REG_PLG] = self::UD_OPT_1;
    */
        return $ftMap[$ft];
    }

    /**
     * @param $ft
     * @return mixed
     */
    public static function getFtSetting($ft){
        $ftMap = self::getFtMap();
        if(array_key_exists($ft, $ftMap)){
            return $ftMap[$ft];
        }
        return null;
    }

    /**
     * @param bool $includeVersion
     * @param bool $includeBuild
     * @return string
     */
    public static function getProductName($includeVersion=false, $includeBuild=true){
        if($includeVersion){
            return (self::PT_NAME.' '.self::getProductVersion($includeBuild));
        }
        return self::PT_NAME;
    }

    /**
     * @return string
     */
    public static function getProductDate(){
        return self::PT_DATE;
    }

    /**
     * @param bool $includeBuild
     * @param bool $includeBeta
     * @return string
     */
    public static function getProductVersion($includeBuild=false, $includeBeta=true){
        $version = self::PT_TOP.'.'.self::PT_SUB.'.'.self::PT_FIX;
        if($includeBeta && self::PT_BET && strlen(self::PT_BET)>0 && self::PT_BET !== '-'){
            $version .= ' - '.self::PT_BET;
        }
        if($includeBuild){
            return ($version.' BUILD '.self::PT_BLD);
        }
        return $version;
    }

    /**
     * @return bool
     */
    public static function upgradePossible(){
        return (self::UD_OK === 'true');
    }

    /**
     * @return string
     */
    public static function getUpgradeLink(){
        return self::UD_LINK;
    }

    /**
     * @return string
     */
    public static function getUpgradeOption(){
        return self::UD_VERSION;
    }
    
}