<?php
/**
 * @copyright (C) 2021 - 2022 Holger Brandt IT Solutions
 * @license GPL2
*/

if(!defined('ABSPATH')){
    exit;
}

class WADA_CompUtils
{
    /**
     * @param object $previousObj
     * @param object $currentObject
     * @param array $attributes2Check
     * @return array
     */
	public static function getChangedAttributes($previousObj, $currentObject, $attributes2Check, $returnAsEventInfoObj = true){
        $changedAttributes = array();

        foreach($attributes2Check AS $attribute2Check){
            if(!isset($previousObj->$attribute2Check) && !isset($currentObject->$attribute2Check)){
                continue;
            }
            $priorValue = isset($previousObj->$attribute2Check) ? $previousObj->$attribute2Check : null;
            $currentValue = isset($currentObject->$attribute2Check) ? $currentObject->$attribute2Check : null;
            WADA_Log::debug('getChangedAttributes '.$attribute2Check.': '.$priorValue.' -> '.$currentValue);

            if($priorValue != $currentValue){
                if($returnAsEventInfoObj) {
                    $changedAttributes[] = array(
                        'info_key' => $attribute2Check,
                        'info_value' => $currentValue,
                        'prior_value' => $priorValue
                    );
                }else{
                    $changedAttributes[] = $attribute2Check;
                }
            }
        }
        //WADA_Log::debug('getChangedAttributes result: '.print_r($changedAttributes, true));

        return $changedAttributes;
    }

}
