<?php
/**
 * @copyright (C) 2021 - 2022 Holger Brandt IT Solutions
 * @license GPL2
*/

if(!defined('ABSPATH')){
    exit;
}

class WADA_Layout_PostOutline implements WADA_Layout_LayoutInterface
{
    const LAYOUT_IDENTIFIER = 'wada-layout-post-outline';
    public $wpPost;
    public $postId;

    /**
     * @param WP_Post $wpPost
     */
    public function __construct($wpPost, $postId){
        $this->wpPost = $wpPost;
        $this->postId = $postId;
    }

    public function display($returnAsHtml = false){
        if($returnAsHtml){
            ob_start();
        }
        if($this->wpPost):
    ?>
        <div class="<?php echo self::LAYOUT_IDENTIFIER; ?>">
            <?php
            $postDate = WADA_DateUtils::formatWPDatetimeForWP($this->wpPost->post_date);
            ?>
            <table class="data">
                <tbody>
                <tr>
                    <td class="label"><?php _e('ID', 'wp-admin-audit'); ?></td>
                    <td class="value"><?php echo esc_html($this->wpPost->ID); ?></td>
                </tr>
                <tr>
                    <td class="label"><?php _e('Title', 'wp-admin-audit'); ?></td>
                    <td class="value"><?php echo esc_html($this->wpPost->post_title); ?></td>
                </tr>
                <tr>
                    <td class="label"><?php _e('Date', 'wp-admin-audit'); ?></td>
                    <td class="value"><?php echo esc_html($postDate); ?></td>
                </tr>
                <tr>
                    <td class="label"><?php _e('Type', 'wp-admin-audit'); ?></td>
                    <td class="value"><?php echo esc_html($this->wpPost->post_type); ?></td>
                </tr>
                </tbody>
            </table>
        </div>
    <?php
        else: ?>
        <div class="<?php echo self::LAYOUT_IDENTIFIER; ?>">
            <table class="data">
                <tbody>
                <tr>
                    <td class="label"><?php _e('ID', 'wp-admin-audit'); ?></td>
                    <td class="value"><?php echo esc_html($this->postId); ?></td>
                </tr>
                <tr>
                    <td class="value" colspan="2"><strong><?php _e('Post no longer existing', 'wp-admin-audit'); ?></strong></td>
                </tr>
                </tbody>
            </table>
        </div>
    <?php
        endif;

        if($returnAsHtml){
            $html = ob_get_contents();
            ob_end_clean();
            return $html;
        }
    }
}