<?php
/**
 * @copyright (C) 2021 - 2022 Holger Brandt IT Solutions
 * @license GPL2
*/

if(!defined('ABSPATH')){
    exit;
}

class WADA_View_Notifications extends WADA_View_BaseForm
{
    const VIEW_IDENTIFIER = 'wada-notifications';

    protected function handleFormSubmissions(){
        if(isset($_POST['submit'])){
            check_admin_referer(self::VIEW_IDENTIFIER);
        }
    }

    protected function displayForm(){
    ?>
        <div class="wrap">
            <h1><?php _e('Notifications', 'wp-admin-audit') ?></h1>
            <form id="<?php echo self::VIEW_IDENTIFIER; ?>" method="post">
                <?php wp_nonce_field(self::VIEW_IDENTIFIER); ?>
                <input type="hidden" name="page" value="<?php echo esc_attr($this->getCurrentPage()); ?>" />
                <div>
                    <div>
                        <h3><?php _e('It\'s coming', 'wp-admin-audit'); ?></h3>
                        <?php _e('We are working on a powerful notification system', 'wp-admin-audit') ?>
                        <ul class="wada-ul">
                            <li><?php _e('get immediately notified about security relevant activities', 'wp-admin-audit'); ?></li>
                            <li><?php _e('switch on / off notifications for certain sensors and/or certain admins', 'wp-admin-audit'); ?></li>
                            <li><?php _e('choose your preferred channel between email & text messages', 'wp-admin-audit'); ?></li>
                        </ul>
                    </div>
                    <div>
                        <h3><?php _e('We need your help', 'wp-admin-audit'); ?></h3>
                        <p><?php _e('Before we roll out the notifications to everyone, we want to do a round of testing with a group of enthusiastic beta testers.', 'wp-admin-audit'); ?></p>
                        <p><em><?php _e('Are you in?', 'wp-admin-audit'); ?></em></p>
                    </div>
                    <p class="submit"><a href="<?php echo admin_url( 'admin.php?page=wp-admin-audit-info&tab=tab-3&mode=beta&src=notifications' );?>" class="button button-primary"><?php esc_attr_e('Yes, let me know once it is ready for testing!', 'wp-admin-audit'); ?></a></p>
                </div>
            </form>
        </div>
    <?php
    }


}